package logging

import (
	"fmt"
	"os"
	"path/filepath"

	"git.sr.ht/~cco/go-scopes/config"
	"git.sr.ht/~cco/go-scopes/lib"
	"github.com/rs/zerolog"
	"github.com/rs/zerolog/log"
)

type Logger = zerolog.Logger

var globalLogger *Logger = &log.Logger

type Cfg struct {
	*config.BaseCfg
	Logfile string
	Level   zerolog.Level
}

func Setup(ctx lib.Context, cfg *Cfg, home string) {
	if cfg == nil {
		return // use unchanged predefined logger
	}
	if logger, err := New(cfg, home); err != nil {
		//panic(err)
		logger.Err(err)
		//GetLogger(nil).Err(err)
	} else {
		*globalLogger = logger
	}
}

func New(cfg *Cfg, home string) (Logger, error) {
	home, _ = filepath.Abs(home)
	fn := cfg.Logfile
	if fn == "" {
		fn = filepath.Join(home, "log", "scopes.log")
	} else if !filepath.IsAbs(fn) {
		fn = filepath.Join(home, fn)
	}
	fmt.Println("logfile:", fn)
	f, err := os.OpenFile(fn, os.O_WRONLY|os.O_APPEND|os.O_CREATE, 0664)
	if err != nil {
		return *globalLogger, err
	}
	return zerolog.New(f).With().Timestamp().Logger(), nil
}

func GetLogger(ctx lib.Context) *Logger {
	if ctx == nil {
		return globalLogger
	}
	// return ctx.Logger()
	return nil
}
